TYPE cycle
        active AS INTEGER
        hor AS INTEGER
        vert AS INTEGER
        dir AS INTEGER
END TYPE
TYPE pup
        x AS INTEGER
        y AS INTEGER
END TYPE
DIM bike(4) AS cycle
DIM power AS pup
DIM time(4)
DIM t(4)
DIM p(4)
DIM f(4)
DIM k(4)
DIM c(4)
DIM dead(4)
DECLARE SUB title ()
DECLARE SUB hitpower (bike() AS cycle, power AS pup, p(), a)
DECLARE SUB poweroff (power AS pup)
DECLARE SUB setpowerup (power AS pup, a)
DECLARE SUB inputs (bike() AS cycle, p(), f())
DECLARE SUB bikeActive2 (bike() AS cycle)
DECLARE SUB bikeActive3 (bike() AS cycle)
DECLARE SUB bikeActive4 (bike() AS cycle)
DECLARE SUB bikeActive1 (bike() AS cycle)
DECLARE SUB setup (x, speed, dots, vanish, p)
DECLARE SUB start (bike() AS cycle, x, speed, dots, vanish, t())
DECLARE SUB whowon (bike() AS cycle, t(), winner)
DECLARE SUB bike1collide (bike() AS cycle, k(), vanish, death)
DECLARE SUB bike2collide (bike() AS cycle, k(), vanish, death)
DECLARE SUB bike3collide (bike() AS cycle, k(), vanish, death)
DECLARE SUB bike4collide (bike() AS cycle, k(), vanish, death)
st:
SCREEN 12
COLOR 15
CLS
title
LOCATE 25, 7
PRINT "What PC are you on (2=286,3=386,4=486,5=Pentium,Default Pentium)"
reent:
LOCATE 26, 34
INPUT pc
IF pc = 0 THEN pc = 5
IF pc = 2 THEN max = 100
IF pc = 3 THEN max = 300
IF pc = 4 THEN max = 700
IF pc = 5 THEN max = 15000
IF pc < 0 OR pc > 5 THEN GOTO reent:


REM      *********************  Main Program  ***********************
main:
COLOR 15
setup x, speed, dots, vanish, p
FOR g = 1 TO 4
t(g) = 0
NEXT g


REM *************************  Main Game Loop  *************************
s:
a = 0: ap = 0
FOR g = 1 TO 4
tstop(g) = 0
time(g) = 0
p(g) = 0
f(g) = 0
c(g) = 0
k(g) = 0
NEXT g
SCREEN 12
COLOR 15
tim = TIMER
start bike(), x, speed, dots, vanish, t()
PALETTE
death = 0
IF x >= 1 THEN dead(1) = 0 ELSE dead(1) = 1
IF x >= 2 THEN dead(2) = 0 ELSE dead(2) = 1
IF x >= 3 THEN dead(3) = 0 ELSE dead(3) = 1
IF x >= 4 THEN dead(4) = 0 ELSE dead(4) = 1

DO
' Changes position
IF bike(1).active = 1 THEN bikeActive1 bike()
IF bike(2).active = 1 THEN bikeActive2 bike()
IF bike(3).active = 1 THEN bikeActive3 bike()
IF bike(4).active = 1 THEN bikeActive4 bike()

' Inputs
inputs bike(), p(), f()

' first part of Collision routine - deals with other players
IF bike(1).active = 1 THEN bike1collide bike(), k(), vanish, death
IF vanish = 1 AND bike(1).active = 0 AND dead(1) = 0 THEN PALETTE 2, 0: k(1) = 1: dead(1) = 1

IF bike(2).active = 1 THEN bike2collide bike(), k(), vanish, death
IF vanish = 1 AND bike(2).active = 0 AND dead(2) = 0 THEN PALETTE 9, 0: k(2) = 1: dead(2) = 1

IF bike(3).active = 1 THEN bike3collide bike(), k(), vanish, death
IF vanish = 1 AND bike(3).active = 0 AND dead(3) = 0 THEN PALETTE 4, 0: k(3) = 1: dead(3) = 1

IF bike(4).active = 1 THEN bike4collide bike(), k(), vanish, death
IF vanish = 1 AND bike(4).active = 0 AND dead(4) = 0 THEN PALETTE 14, 0: k(4) = 1: dead(4) = 1

' Second part of Collision routine - deals with wall and your player
IF bike(1).active = 1 AND (POINT(bike(1).hor, bike(1).vert) = 15 OR POINT(bike(1).hor, bike(1).vert) = 2) THEN bike(1).active = 0: death = death + 1: SOUND 2800, 1
IF bike(2).active = 1 AND (POINT(bike(2).hor, bike(2).vert) = 15 OR POINT(bike(2).hor, bike(2).vert) = 9) THEN bike(2).active = 0: death = death + 1: SOUND 2800, 1
IF bike(3).active = 1 AND (POINT(bike(3).hor, bike(3).vert) = 15 OR POINT(bike(3).hor, bike(3).vert) = 4) THEN bike(3).active = 0: death = death + 1: SOUND 2800, 1
IF bike(4).active = 1 AND (POINT(bike(4).hor, bike(4).vert) = 15 OR POINT(bike(4).hor, bike(4).vert) = 14) THEN bike(4).active = 0: death = death + 1: SOUND 2800, 1

'**************      Power-up routine

ap = ap + 1
IF p = 0 AND a = 0 AND ap > 425 THEN setpowerup power, a
IF p = 0 AND a = 1 THEN hitpower bike(), power, p(), a: ap = 0

IF f(1) = 1 THEN c(1) = 50: f(1) = 0: LOCATE 29, 8: PRINT USING "##"; p(1);
IF f(2) = 1 THEN c(2) = 50: f(2) = 0: LOCATE 29, 10: PRINT USING "##"; p(2);
IF f(3) = 1 THEN c(3) = 50: f(3) = 0: LOCATE 29, 12: PRINT USING "##"; p(3);
IF f(4) = 1 THEN c(4) = 50: f(4) = 0: LOCATE 29, 14: PRINT USING "##"; p(4);

IF c(1) > 0 THEN c(1) = c(1) - 1: LOCATE 29, 38: PRINT USING "##"; c(1); : COLOR 2: PSET (bike(1).hor, bike(1).vert): bikeActive1 bike()
IF c(1) > 0 AND c(1) MOD 10 = 0 THEN SOUND 3000, 1

IF c(2) > 0 THEN c(2) = c(2) - 1: LOCATE 29, 40: PRINT USING "##"; c(2); : COLOR 9: PSET (bike(2).hor, bike(2).vert): bikeActive2 bike()
IF c(2) > 0 AND c(2) MOD 10 = 0 THEN SOUND 3000, 1

IF c(3) > 0 THEN c(3) = c(3) - 1: LOCATE 29, 42: PRINT USING "##"; c(3); : COLOR 4: PSET (bike(3).hor, bike(3).vert): bikeActive3 bike()
IF c(3) > 0 AND c(3) MOD 10 = 0 THEN SOUND 3000, 1

IF c(4) > 0 THEN c(4) = c(4) - 1: LOCATE 29, 44: PRINT USING "##"; c(4); : COLOR 14: PSET (bike(4).hor, bike(4).vert): bikeActive4 bike()
IF c(4) > 0 AND c(4) MOD 10 = 0 THEN SOUND 3000, 1
COLOR 15

'******************      Line Drawing
IF bike(1).active = 1 THEN COLOR 2: PSET (bike(1).hor, bike(1).vert)
IF bike(2).active = 1 THEN COLOR 9: PSET (bike(2).hor, bike(2).vert)
IF bike(3).active = 1 THEN COLOR 4: PSET (bike(3).hor, bike(3).vert)
IF bike(4).active = 1 THEN COLOR 14: PSET (bike(4).hor, bike(4).vert)
COLOR 15

'Timing loop
FOR delay = 1 TO max / speed: NEXT delay

IF death = x - 1 AND x > 1 THEN whowon bike(), t(), winner

IF bike(1).active = 0 AND tstop(1) = 0 THEN time(1) = TIMER: tstop(1) = 1
IF bike(2).active = 0 AND tstop(2) = 0 THEN time(2) = TIMER: tstop(2) = 1
IF bike(3).active = 0 AND tstop(3) = 0 THEN time(3) = TIMER: tstop(3) = 1
IF bike(4).active = 0 AND tstop(4) = 0 THEN time(4) = TIMER: tstop(4) = 1

LOOP UNTIL bike(1).active = 0 AND bike(2).active = 0 AND bike(3).active = 0 AND bike(4).active = 0

REM *********** After game display, including score

IF x < 4 THEN time(4) = tim
IF x < 3 THEN time(3) = tim
IF x < 2 THEN time(2) = tim
dif = pc * speed

LOCATE 10, 31
PRINT " The scores were "

PALETTE
score(1) = (time(1) - tim) * dif * (p(1) + 1)
score(2) = (time(2) - tim) * dif * (p(2) + 1)
score(3) = (time(3) - tim) * dif * (p(3) + 1)
score(4) = (time(4) - tim) * dif * (p(4) + 1)

IF x > 1 THEN score(winner) = 2 * score(winner)

COLOR 2
LOCATE 11, 21
PRINT "  Green"
LOCATE 12, 21
PRINT USING "#######"; score(1)
IF x = 1 THEN GOTO ch:

COLOR 9
LOCATE 11, 30
PRINT "   Blue"
LOCATE 12, 30
PRINT USING "#######"; score(2)
IF x = 2 THEN GOTO ch:

COLOR 4
LOCATE 11, 41
PRINT "    Red"
LOCATE 12, 41
PRINT USING "#######"; score(3)
IF x = 3 THEN GOTO ch:

COLOR 14
LOCATE 11, 52
PRINT " Yellow"
LOCATE 12, 52
PRINT USING "#######"; score(4)

ch:
COLOR 15
LOCATE 16, 33
PRINT "Play Again    0"
LOCATE 17, 33
PRINT "Restart Game  1"
LOCATE 18, 33
PRINT "End Game      2"
LOCATE 19, 33
INPUT g

IF g <> 1 AND g <> 2 THEN GOTO s:
IF g = 1 THEN GOTO main:
IF g = 2 THEN GOTO n:
n:
SYSTEM

SUB bike1collide (bike() AS cycle, k(), vanish, death)
IF k(2) = 0 AND POINT(bike(1).hor, bike(1).vert) = 9 THEN bike(1).active = 0: death = death + 1: k(1) = 1: SOUND 2800, 1
IF k(3) = 0 AND POINT(bike(1).hor, bike(1).vert) = 4 THEN bike(1).active = 0: death = death + 1: k(1) = 1: SOUND 2800, 1
IF k(4) = 0 AND POINT(bike(1).hor, bike(1).vert) = 14 THEN bike(1).active = 0: death = death + 1: k(1) = 1: SOUND 2800, 1

IF k(2) = 1 AND vanish = 0 AND POINT(bike(1).hor, bike(1).vert) = 9 THEN bike(1).active = 0: death = death + 1: k(1) = 1: SOUND 2800, 1
IF k(3) = 1 AND vanish = 0 AND POINT(bike(1).hor, bike(1).vert) = 4 THEN bike(1).active = 0: death = death + 1: k(1) = 1: SOUND 2800, 1
IF k(4) = 1 AND vanish = 0 AND POINT(bike(1).hor, bike(1).vert) = 14 THEN bike(1).active = 0: death = death + 1: k(1) = 1: SOUND 2800, 1
END SUB

SUB bike2collide (bike() AS cycle, k(), vanish, death)
IF k(1) = 0 AND POINT(bike(2).hor, bike(2).vert) = 2 THEN bike(2).active = 0: death = death + 1: k(2) = 1: SOUND 2800, 1
IF k(3) = 0 AND POINT(bike(2).hor, bike(2).vert) = 4 THEN bike(2).active = 0: death = death + 1: k(2) = 1: SOUND 2800, 1
IF k(4) = 0 AND POINT(bike(2).hor, bike(2).vert) = 14 THEN bike(2).active = 0: death = death + 1: k(2) = 1: SOUND 2800, 1

IF k(1) = 1 AND vanish = 0 AND POINT(bike(2).hor, bike(2).vert) = 2 THEN bike(2).active = 0: death = death + 1: k(2) = 1: SOUND 2800, 1
IF k(3) = 1 AND vanish = 0 AND POINT(bike(2).hor, bike(2).vert) = 4 THEN bike(2).active = 0: death = death + 1: k(2) = 1: SOUND 2800, 1
IF k(4) = 1 AND vanish = 0 AND POINT(bike(2).hor, bike(2).vert) = 14 THEN bike(2).active = 0: death = death + 1: k(2) = 1: SOUND 2800, 1
END SUB

SUB bike3collide (bike() AS cycle, k(), vanish, death)
IF k(1) = 0 AND POINT(bike(3).hor, bike(3).vert) = 2 THEN bike(3).active = 0: death = death + 1: k(3) = 1: SOUND 2800, 1
IF k(2) = 0 AND POINT(bike(3).hor, bike(3).vert) = 9 THEN bike(3).active = 0: death = death + 1: k(3) = 1: SOUND 2800, 1
IF k(4) = 0 AND POINT(bike(3).hor, bike(3).vert) = 14 THEN bike(3).active = 0: death = death + 1: k(3) = 1: SOUND 2800, 1

IF k(1) = 1 AND vanish = 0 AND POINT(bike(3).hor, bike(3).vert) = 2 THEN bike(3).active = 0: death = death + 1: k(3) = 1: SOUND 2800, 1
IF k(2) = 1 AND vanish = 0 AND POINT(bike(3).hor, bike(3).vert) = 9 THEN bike(3).active = 0: death = death + 1: k(3) = 1: SOUND 2800, 1
IF k(4) = 1 AND vanish = 0 AND POINT(bike(3).hor, bike(3).vert) = 14 THEN bike(3).active = 0: death = death + 1: k(3) = 1: SOUND 2800, 1

END SUB

SUB bike4collide (bike() AS cycle, k(), vanish, death)
IF k(1) = 0 AND POINT(bike(4).hor, bike(4).vert) = 2 THEN bike(4).active = 0: death = death + 1: k(4) = 1: SOUND 2800, 1
IF k(2) = 0 AND POINT(bike(4).hor, bike(4).vert) = 9 THEN bike(4).active = 0: death = death + 1: k(4) = 1: SOUND 2800, 1
IF k(3) = 0 AND POINT(bike(4).hor, bike(4).vert) = 4 THEN bike(4).active = 0: death = death + 1: k(4) = 1: SOUND 2800, 1

IF k(1) = 1 AND vanish = 0 AND POINT(bike(4).hor, bike(4).vert) = 2 THEN bike(4).active = 0: death = death + 1: k(4) = 1: SOUND 2800, 1
IF k(2) = 1 AND vanish = 0 AND POINT(bike(4).hor, bike(4).vert) = 9 THEN bike(4).active = 0: death = death + 1: k(4) = 1: SOUND 2800, 1
IF k(3) = 1 AND vanish = 0 AND POINT(bike(4).hor, bike(4).vert) = 4 THEN bike(4).active = 0: death = death + 1: k(4) = 1: SOUND 2800, 1
END SUB

SUB bikeActive1 (bike() AS cycle)
IF bike(1).dir = 1 THEN bike(1).vert = bike(1).vert - 1
IF bike(1).dir = 2 THEN bike(1).hor = bike(1).hor + 1
IF bike(1).dir = 3 THEN bike(1).vert = bike(1).vert + 1
IF bike(1).dir = 4 THEN bike(1).hor = bike(1).hor - 1

END SUB

SUB bikeActive2 (bike() AS cycle)
IF bike(2).dir = 1 THEN bike(2).vert = bike(2).vert - 1
IF bike(2).dir = 2 THEN bike(2).hor = bike(2).hor + 1
IF bike(2).dir = 3 THEN bike(2).vert = bike(2).vert + 1
IF bike(2).dir = 4 THEN bike(2).hor = bike(2).hor - 1

END SUB

SUB bikeActive3 (bike() AS cycle)
IF bike(3).dir = 1 THEN bike(3).vert = bike(3).vert - 1
IF bike(3).dir = 2 THEN bike(3).hor = bike(3).hor + 1
IF bike(3).dir = 3 THEN bike(3).vert = bike(3).vert + 1
IF bike(3).dir = 4 THEN bike(3).hor = bike(3).hor - 1

END SUB

SUB bikeActive4 (bike() AS cycle)
IF bike(4).dir = 1 THEN bike(4).vert = bike(4).vert - 1
IF bike(4).dir = 2 THEN bike(4).hor = bike(4).hor + 1
IF bike(4).dir = 3 THEN bike(4).vert = bike(4).vert + 1
IF bike(4).dir = 4 THEN bike(4).hor = bike(4).hor - 1

END SUB

SUB hitpower (bike() AS cycle, power AS pup, p(), a)
IF bike(1).active = 0 THEN GOTO d1:
IF bike(1).hor > (power.x - 10) AND bike(1).hor < (power.x + 10) AND bike(1).vert > (power.y - 10) AND bike(1).vert < (power.y + 10) THEN p(1) = p(1) + 1: LOCATE 29, 8: PRINT p(1); : a = 0: LINE (power.x - 1, power.y - 1)-(power.x + 1, power.y + 1), 0, BF
d1:
IF bike(2).active = 0 THEN GOTO d2:
IF bike(2).hor > (power.x - 10) AND bike(2).hor < (power.x + 10) AND bike(2).vert > (power.y - 10) AND bike(2).vert < (power.y + 10) THEN p(2) = p(2) + 1: LOCATE 29, 10: PRINT p(2); : a = 0: LINE (power.x - 1, power.y - 1)-(power.x + 1, power.y + 1), 0, BF
d2:
IF bike(3).active = 0 THEN GOTO d3:
IF bike(3).hor > (power.x - 10) AND bike(3).hor < (power.x + 10) AND bike(3).vert > (power.y - 10) AND bike(3).vert < (power.y + 10) THEN p(3) = p(3) + 1: LOCATE 29, 12: PRINT p(3); : a = 0: LINE (power.x - 1, power.y - 1)-(power.x + 1, power.y + 1), 0, BF
d3:
IF bike(4).active = 0 THEN GOTO d4:
IF bike(4).hor > (power.x - 10) AND bike(4).hor < (power.x + 10) AND bike(4).vert > (power.y - 10) AND bike(4).vert < (power.y + 20) THEN p(4) = p(4) + 1: LOCATE 29, 14: PRINT p(4); : a = 0: LINE (power.x - 1, power.y - 1)-(power.x + 1, power.y + 1), 0, BF
d4:
IF a = 0 THEN SOUND 1800, 1

END SUB

SUB inputs (bike() AS cycle, p(), f())
kbd$ = INKEY$
s$ = UCASE$(kbd$)
r$ = CHR$(0)
IF bike(1).active = 0 THEN GOTO m1:
SELECT CASE s$
' Player 1
        CASE r$ + "H": IF bike(1).dir <> 3 THEN bike(1).dir = 1
        CASE r$ + "P": IF bike(1).dir <> 1 THEN bike(1).dir = 3
        CASE r$ + "K": IF bike(1).dir <> 2 THEN bike(1).dir = 4
        CASE r$ + "M": IF bike(1).dir <> 4 THEN bike(1).dir = 2
        CASE r$ + CHR$(79): IF p(1) > 0 AND bike(1).active = 1 THEN f(1) = 1: p(1) = p(1) - 1
END SELECT
m1:
IF bike(2).active = 0 THEN GOTO m2:
SELECT CASE s$
' Player 2
        CASE "W": IF bike(2).dir <> 3 THEN bike(2).dir = 1
        CASE "S": IF bike(2).dir <> 1 THEN bike(2).dir = 3
        CASE "A": IF bike(2).dir <> 2 THEN bike(2).dir = 4
        CASE "D": IF bike(2).dir <> 4 THEN bike(2).dir = 2
        CASE "E": IF p(2) > 0 AND bike(2).active = 1 THEN f(2) = 1: p(2) = p(2) - 1
END SELECT
m2:
IF bike(3).active = 0 THEN GOTO m3:
SELECT CASE s$
' Player 3
        CASE r$ + CHR$(81), "3": IF bike(3).dir <> 3 THEN bike(3).dir = 1
        CASE r$ + CHR$(83), ".": IF bike(3).dir <> 1 THEN bike(3).dir = 3
        CASE r$ + CHR$(82), "0": IF bike(3).dir <> 2 THEN bike(3).dir = 4
        CASE CHR$(13): IF bike(3).dir <> 4 THEN bike(3).dir = 2
        CASE "+": IF p(3) > 0 AND bike(3).active = 1 THEN f(3) = 1: p(3) = p(3) - 1
END SELECT
m3:
IF bike(4).active = 0 THEN GOTO m4:
SELECT CASE s$
' Player 4
        CASE "J": IF bike(4).dir <> 3 THEN bike(4).dir = 1
        CASE "N": IF bike(4).dir <> 1 THEN bike(4).dir = 3
        CASE "B": IF bike(4).dir <> 2 THEN bike(4).dir = 4
        CASE "M": IF bike(4).dir <> 4 THEN bike(4).dir = 2
        CASE "H": IF p(4) > 0 AND bike(4).active = 1 THEN f(4) = 1: p(4) = p(4) - 1
END SELECT
m4:
END SUB

SUB setpowerup (power AS pup, a)
RANDOMIZE TIMER
power.x = INT(RND * 560 + 20)
power.y = INT(RND * 400 + 20)
a = 1
LINE (power.x - 1, power.y - 1)-(power.x + 1, power.y + 1), 15, BF
SOUND 400, 2
END SUB

SUB setup (x, speed, dots, vanish, p)
m:
CLS
PRINT "                                     Keys"
PRINT "       Player 1          Player 2             Player 3         Player 4"
PRINT
PRINT USING "          !                 W                    3                J"; CHR$(24)
PRINT USING "        !   !             A   D                0  Enter         B   M"; CHR$(27); CHR$(26)
PRINT USING "          !                 S                    .                N"; CHR$(25)
PRINT "  Power"
PRINT "  Key    End                E                    +                H"
PRINT
PRINT "How many players (1-4, Default=1)"
INPUT x
IF x = 0 THEN x = 1
IF x > 4 THEN GOTO m:
ws:
PRINT "What speed do you want to play at (Default=100)"
INPUT speed
IF speed = 0 THEN speed = 100
IF speed > 15000 THEN PRINT "Too high": GOTO ws:
IF x > 1 THEN PRINT "Do you want the tracks to disappear when that player dies (1=Yes 0=No)"
IF x > 1 THEN INPUT vanish
PRINT "How many dots (Default=0)"
INPUT dots
PRINT "Do you want to play without power ups (0=No, 1=Yes, Default=0)"
INPUT p
END SUB

SUB start (bike() AS cycle, x, speed, dots, vanish, t())
CLS
LINE (2, 2)-(638, 440), 15, B
LINE (1, 1)-(637, 439), 15, B
t = 444
bo = 466
FOR d = 52 TO 548 STEP 240
LINE (d, t)-(d + 22, bo), 2, B
IF x > 1 THEN LINE (d + 24, t)-(d + 46, bo), 9, B
IF x > 2 THEN LINE (d + 48, t)-(d + 70, bo), 4, B
IF x > 3 THEN LINE (d + 72, t)-(d + 94, bo), 14, B
NEXT d
LOCATE 29, 1
PRINT "Power   0  0  0  0           Energy   0  0  0  0            Score   ";

LOCATE 29, 68
PRINT USING "## ## ## ##"; t(1); t(2); t(3); t(4);

IF x > 0 THEN bike(1).active = 1
IF x > 1 THEN bike(2).active = 1
IF x > 2 THEN bike(3).active = 1
IF x = 4 THEN bike(4).active = 1
IF x > 4 OR x < 1 THEN setup x, speed, dots, vanish, p

IF bike(1).active = 1 THEN bike(1).hor = 40: bike(1).vert = 40: bike(1).dir = 2
IF bike(2).active = 1 THEN bike(2).hor = 600: bike(2).vert = 400: bike(2).dir = 4
IF bike(3).active = 1 THEN bike(3).hor = 40: bike(3).vert = 400: bike(3).dir = 1
IF bike(4).active = 1 THEN bike(4).hor = 600: bike(4).vert = 40: bike(4).dir = 3

IF x > 1 OR dots = -1 THEN GOTO e:
FOR a = 1 TO dots
m = RND * 640
n = RND * 440
LINE (m, n)-(m, n), 15
NEXT a

e:
END SUB

SUB title
DIM s$(10)
q$ = CHR$(178)
w$ = CHR$(2)
RANDOMIZE TIMER
s$(1) = "Distant though the last line be "
s$(2) = "  Heroes up the line to death   "
s$(3) = "Line is length without breadth  "
s$(4) = "        Line upon line          "
s$(5) = "     Lives along the line       "
s$(6) = "     We carved not a line       "
s$(7) = "   Will the line stretch out    "
s$(8) = "    Lines and life are free     "
s$(9) = "Liquid lines mellifluously bland"
s$(10) = "    In the very first line      "

y = INT(RND * 10)
FOR x = 1 TO 10
IF y >= x - 1 AND y <= x THEN statement$ = s$(x)
NEXT x

PRINT
PRINT
PRINT "                        "
PRINT "                                      "
PRINT USING "        !!!!!!!!!       !!!!!!!        !!!!!!!        !         !"; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$
PRINT USING "            !           !   !      !    !       !         !"; q$; q$; q$; q$; q$; q$; q$
PRINT USING "            !           !   !      !    !       ! !       !"; q$; q$; q$; q$; q$; q$; q$; q$
PRINT USING "            !           !!!!!!!       !    !       !   !     !"; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$
PRINT USING "            !           !!         !    !       !     !   !"; q$; q$; q$; q$; q$; q$; q$; q$
PRINT USING "            !           !  !        !    !       !       ! !"; q$; q$; q$; q$; q$; q$; q$; q$
PRINT USING "            !           !  !        !    !       !         !"; q$; q$; q$; q$; q$; q$; q$
PRINT USING "            !           !   !       !!!!!!!        !         !"; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$; q$
PRINT "                                      "
PRINT "                        "
PRINT
PRINT USING "                         ! By Andrew Campbell !"; w$; w$
PRINT
PRINT
PRINT
PRINT "                  Ŀ"
PRINT "                    "; statement$; " "
PRINT "                  "

END SUB

SUB whowon (bike() AS cycle, t(), winner)
IF bike(1).active = 0 THEN b1 = 0 ELSE b1 = 1
IF bike(2).active = 0 THEN b2 = 0 ELSE b2 = 1
IF bike(3).active = 0 THEN b3 = 0 ELSE b3 = 1
IF bike(4).active = 0 THEN b4 = 0 ELSE b4 = 1
COLOR 15
IF b2 = 0 AND b3 = 0 AND b4 = 0 THEN LOCATE 7, 35: PRINT "Green wins": bike(1).active = 0: t(1) = t(1) + 1: winner = 1: GOTO won:
IF b3 = 0 AND b4 = 0 AND b1 = 0 THEN LOCATE 7, 35: PRINT " Blue wins": bike(2).active = 0: t(2) = t(2) + 1: winner = 2: GOTO won:
IF b4 = 0 AND b1 = 0 AND b2 = 0 THEN LOCATE 7, 35: PRINT " Red wins": bike(3).active = 0: t(3) = t(3) + 1: winner = 3: GOTO won:
IF b1 = 0 AND b2 = 0 AND b3 = 0 THEN LOCATE 7, 35: PRINT "Yellow wins": bike(4).active = 0: t(4) = t(4) + 1: winner = 4: GOTO won:
won:

END SUB

